#ifndef USERSCSI_H
#define USERSCSI_H

/*
 * Copyright (C) 2002 Bjrn Englund
 */


#include <inttypes.h>

#if defined(__linux__)

#include <linux/cdrom.h>


typedef enum {
  USERSCSI_CMD_WRITE     = 0x00000,
  USERSCSI_CMD_SILENT    = 0x00001,
  USERSCSI_CMD_DIAGNOSE  = 0x00002,
  USERSCSI_CMD_READ      = 0x00008,
  USERSCSI_CMD_ISOLATE   = 0x00004,
  USERSCSI_CMD_RESET     = 0x04000,
  USERSCSI_CMD_RESET_ALL = 0x08000,
  USERSCSI_CMD_RQENABLE  = 0x10000
} userscsi_cmd_flags_t;

#elif defined(__sun__)

#include <sys/scsi/impl/uscsi.h>

typedef enum {
  USERSCSI_CMD_WRITE     = USCSI_WRITE,
  USERSCSI_CMD_SILENT    = USCSI_SILENT,
  USERSCSI_CMD_DIAGNOSE  = USCSI_DIAGNOSE,
  USERSCSI_CMD_READ      = USCSI_READ,
  USERSCSI_CMD_ISOLATE   = USCSI_ISOLATE,
  USERSCSI_CMD_RESET     = USCSI_RESET,
  USERSCSI_CMD_RESET_ALL = USCSI_RESET_ALL,
  USERSCSI_CMD_RQENABLE  = USCSI_RQENABLE
} userscsi_cmd_flags_t;

#elif defined(__bsdi__)

#include </sys/dev/scsi/scsi.h>
#include </sys/dev/scsi/scsi_ioctl.h>

typedef enum {
  USERSCSI_CMD_WRITE     = 0x00000,
  USERSCSI_CMD_SILENT    = 0x00001,
  USERSCSI_CMD_DIAGNOSE  = 0x00002,
  USERSCSI_CMD_READ      = 0x00008,
  USERSCSI_CMD_ISOLATE   = 0x00004,
  USERSCSI_CMD_RESET     = 0x04000,
  USERSCSI_CMD_RESET_ALL = 0x08000,
  USERSCSI_CMD_RQENABLE  = 0x10000
} userscsi_cmd_flags_t;

#endif

#include "sam.h"
#include "spc.h"
#include "mmc.h"

typedef struct {
  userscsi_cmd_flags_t flags;     // flags
  uint8_t *cdb;      // command
  uint8_t cdb_len;
  uint8_t status;    // command status
  uint8_t *data;     // i/o data
  int32_t data_len;
  int32_t data_resid;
  uint8_t *rs;       // request_sense_data
  uint8_t rs_len;
  uint8_t rs_status;
  uint8_t rs_resid;
  int16_t timeout;
} userscsi_cmd_t;



int init_userscsi(void);

int userscsi_cmd(int fd, userscsi_cmd_t *cmd);

#endif /* USERSCSI_H */
